#include "labels.h"

typedef struct intlist_struct {
	int data;
	struct intlist_struct* next;
} *intlist;

#define NULL ((void*)0)

/*@ type intlist */
/*@ logic int dataf(intlist l) */
/*@ logic int datafp(intlist l) */
/*@ logic intlist nextf(intlist l) */
/*@ logic intlist nextfp(intlist l) */
/*@ logic flabel nextl() */
/*@ logic flabel nextlp() */

/*@ logic intlist null() */
/*@ predicate reach(intlist v1, flabel_set A, flabel_set B, int l, intlist v2) */

/*  external parameter is_null : intlist -> bool */
/*  external parameter eq_intlist : intlist -> intlist -> bool */
/*  external parameter set_dataf : intlist ref -> int -> unit */
/*  external parameter set_nextf : intlist ref -> intlist -> unit */

/*@ requires reach(x, singleton(nextl()), empty(), -1, null())
    ensures \forall intlist y; \forall int l;
  	(reach(x, singleton(nextl()), empty(), l, y) &&
  	 reach(y, singleton(nextl()), empty(), -1, null()))
  		   => (datafp(y) == dataf(y)+2)
 */
void add2(intlist x) {
  intlist r = x;
  /*@ invariant
     (\forall intlist y; \forall int l;
       (reach(x, singleton(nextl()), empty(), l, y) &&
        reach(y, singleton(nextl()), empty(), -1, r)) =>
       datafp(y) == dataf(y)+2) &&
     (\forall intlist y;
       (reach(r, singleton(nextl()), empty(), -1, y) &&
       reach(y, singleton(nextl()), empty(), -1, null())) =>
       datafp(y) == dataf(y))
   */
  while (r != NULL) {
    r->data = r->data + 2;
    r = r -> next;
  }
}
