# this makefile was automatically generated; do not edit 

TIMEOUT ?= 10

WHY=why --no-arrays -explain -locs add2.loc 

GWHY=gwhy-bin --no-arrays -explain -locs add2.loc 

CADULIB=/usr/local/lib/caduceus

CADULIBFILE=caduceus.why

COQTACTIC=intuition

COQDEP=coqdep -I `coqc -where`/user-contrib

.PHONY: all coq pvs simplify ergo cvcl harvey smtlib cvc3 z3 zenon

all: simplify/add2_why.sx

coq: coq.depend coq/add2_why.vo

coq/add2_spec_why.v: why/add2_spec.why
	@echo 'why -coq-v8 [...] why/add2_spec.why' && $(WHY) -coq-v8 -dir coq -coq-preamble "Require Export Caduceus." $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why

coq/%_why.v: why/add2_spec.why why/%.why
	@echo 'why -coq-v8 [...] why/$*.why' &&$(WHY) -coq-v8 -dir coq -coq-preamble "Require Export add2_spec_why." -coq-tactic "$(COQTACTIC)" $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

coq/%.vo: coq/%.v
	coqc -I coq $<

pvs: pvs/add2_spec_why.pvs pvs/add2_why.pvs

pvs/add2_spec_why.pvs: why/add2_spec.why
	$(WHY) -pvs -dir pvs -pvs-preamble "importing why@why" $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why

pvs/%_why.pvs: pvs/add2_spec_why.pvs why/%.why
	$(WHY) -pvs -dir pvs -pvs-preamble "importing add2_spec_why" $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

pvs/caduceus_why.pvs:
	$(WHY) -pvs -dir pvs $(CADULIB)/why/$(CADULIBFILE)

isabelle: isabelle/add2_why.thy isabelle/add2_spec_why.thy

isabelle/%_spec_why.thy: why/%_spec.why
	$(WHY) -isabelle -dir isabelle -isabelle-base-theory caduceus_why $(CADULIB)/why/$(CADULIBFILE) why/$*_spec.why

isabelle/%_why.thy: isabelle/add2_spec_why.thy why/%.why
	$(WHY) -isabelle -dir isabelle -isabelle-base-theory add2_spec_why $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why
	cp -f /usr/local/lib/caduceus/isabelle/caduceus_why.thy isabelle/

simplify: simplify/add2_why.sx
	@echo 'Running Simplify on proof obligations' && (why-dp -timeout $(TIMEOUT) $^)

simplify/%_why.sx: why/add2_spec.why why/%.why
	@echo 'why -simplify [...] why/$*.why' && $(WHY) -simplify -dir  simplify $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

ergo: why/add2_why.why
	@echo 'Running Ergo on proof obligations' && (why-dp -timeout $(TIMEOUT) $^)

why/%_why.sx: why/add2_spec.why why/%.why
	@echo 'why -why [...] why/$*.why' && $(WHY) -why -dir why $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

project: why/add2.wpr

why/%.wpr: why/add2_ctx.why
	@echo 'why --project [...] why/$*.why' && $(WHY) --project -dir why $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

goals: why/add2_ctx.why

why/%_ctx.why: why/add2_spec.why why/%.why
	@echo 'why --multi-why [...] why/$*.why' && $(WHY) --multi-why -dir why $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

why/%_why.why: why/add2_spec.why why/%.why
	@echo 'why -why [...] why/$*.why' && $(WHY) -why -dir why $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

cvcl: cvcl/add2_why.cvc

	@echo 'Running CVC Lite on proof obligations' && (why-dp -timeout $(TIMEOUT) $^)

cvcl/%_why.cvc: why/add2_spec.why why/%.why
	@echo 'why -cvcl [...] why/$*.why' && $(WHY) -cvcl --encoding sstrat -dir cvcl $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

harvey: harvey/add2_why.rv
	@echo 'Running haRVey on proof obligations' && (why-dp -timeout $(TIMEOUT) $^)

harvey/%_why.rv: why/add2_spec.why why/%.why
	@echo 'why -harvey [...] why/$*.why' && $(WHY) -harvey -dir harvey $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

zenon: zenon/add2_why.znn
	@echo 'Running Zenon on proof obligations' && (why-dp -timeout $(TIMEOUT) $^)

zenon/%_why.znn: why/add2_spec.why why/%.why
	@echo 'why -zenon [...] why/$*.why' && $(WHY) -zenon -dir zenon $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

smtlib: smtlib/add2_why.smt
	@echo 'Running Yices on proof obligations' && (why-dp -timeout $(TIMEOUT) $^)

smtlib/%_why.smt: why/add2_spec.why why/%.why
	@echo 'why -smtlib [...] why/$*.why' && $(WHY) -smtlib --encoding sstrat -exp all   -dir smtlib $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

z3: z3/add2_why.smt
	@echo 'Running Z3 on proof obligations' && (dp -smt-solver z3 -timeout $(TIMEOUT) $^)

z3/%_why.smt: why/add2_spec.why why/%.why
	@echo 'why -smtlib [...] why/$*.why' && $(WHY) -smtlib --encoding sstrat -exp all   -dir z3 $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

cvc3: cvc3/add2_why.smt
	@echo 'Running CVC3 on proof obligations' && (dp -smt-solver cvc3 -timeout $(TIMEOUT) $^)

cvc3/%_why.smt: why/add2_spec.why why/%.why
	@echo 'why -smtlib [...] why/$*.why' && $(WHY) -smtlib --encoding sstrat -exp all   -dir cvc3 $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

gui stat: add2.stat

%.stat: why/add2_spec.why why/%.why
	@echo 'gwhy-bin [...] why/$*.why' && $(GWHY) $(CADULIB)/why/$(CADULIBFILE) why/add2_spec.why why/$*.why

-include add2.depend

coq.depend: coq/add2_spec_why.v coq/add2_why.v
	-$(COQDEP) -I coq coq/add2*_why.v > add2.depend

clean:
	rm -f coq/*.vo

